DWARF_ADD_AT_REF_ADDRESS(3)

NAME
dwarf_add_AT_ref_address - create a reference class attribute descriptor

LIBRARY
libdwarf

SYNOPSIS
#include <libdwarf.h>
Dwarf_P_Attribute
dwarf_add_AT_ref_address(Dwarf_P_Debug dbg, Dwarf_P_Die die, Dwarf_Half attr, Dwarf_Unsigned pc_value, Dwarf_Unsigned sym_index, Dwarf_Error *err);

DESCRIPTION
Function dwarf_add_AT_ref_address() creates a ‘reference’ class attribute descriptor containing a relocatable address value. The created attribute will use DWARF form DW_FORM_ref_addr.

Argument dbg should reference a DWARF producer instance allocated using dwarf_producer_init(3) or dwarf_producer_init_b(3).

Argument die should reference a debugging information entry allocated using dwarf_new_die(3).

Argument attr specifies the attribute code of the created attribute.

Argument pc_value contains a relocatable address which will become the value of the created attribute.

Argument sym_index should specify the ELF symbol index of the symbol to be used when relocating the address value.

If argument err is not NULL, it will be used to store error information in case of an error.

RETURN VALUES
On success, function dwarf_add_AT_ref_address() returns the created attribute descriptor. In case of an error, function dwarf_add_AT_ref_address() returns DW_DLV_BADADDR and sets the argument err.

ERRORS
Function dwarf_add_AT_ref_address() can fail with:

[DW_DLE_ARGUMENT]
    Either of the arguments dbg or die was NULL.

[DW_DLE_MEMORY]
    An out of memory condition was encountered during execution.

SEE ALSO
dwarf(3), dwarf_add_AT_dataref(3), dwarf_add_AT_reference(3), dwarf_add_AT_signed_const(3), dwarf_add_AT_unsigned_const(3), dwarf_new_die(3), dwarf_producer_init(3), dwarf_producer_init_b(3)